<?xml version="1.0" encoding="utf-8"?>
<com.google.android.material.circularreveal.CircularRevealFrameLayout xmlns:android="http://schemas.android.com/apk/res/android"
    xmlns:TagsEditText="http://schemas.android.com/apk/res-auto"
    xmlns:tools="http://schemas.android.com/tools"
    android:layout_width="match_parent"
    android:layout_height="match_parent">

    <FrameLayout
        android:id="@+id/container"
        android:layout_width="match_parent"
        android:layout_height="match_parent">

        <ScrollView
            android:id="@+id/swipeContainer"
            android:layout_width="match_parent"
            android:layout_height="match_parent"
            android:layout_marginStart="@dimen/fab_margin"
            android:layout_marginLeft="@dimen/fab_margin"
            android:layout_marginEnd="@dimen/fab_margin"
            android:layout_marginRight="@dimen/fab_margin"
            android:layout_marginBottom="20dp"
            android:paddingLeft="@dimen/drawer_padding"
            android:paddingRight="@dimen/drawer_padding"
            android:scrollbars="none"
            tools:ignore="UselessParent">


            <LinearLayout
                android:layout_width="match_parent"
                android:layout_height="wrap_content"
                android:gravity="center_vertical"
                android:orientation="vertical"
                android:paddingLeft="@dimen/fab_margin"
                android:paddingRight="@dimen/fab_margin"
                tools:ignore="UselessParent">

                <!--  INTERFACE -->
                <LinearLayout
                    android:id="@+id/settings_interface"
                    android:layout_width="match_parent"
                    android:layout_height="match_parent"
                    android:orientation="vertical">

                    <!-- COMPACT MODE  -->
                    <LinearLayout
                        android:layout_width="match_parent"
                        android:layout_height="wrap_content"
                        android:layout_gravity="center_vertical"
                        android:orientation="horizontal">

                        <TextView
                            android:layout_width="wrap_content"
                            android:layout_height="wrap_content"
                            android:layout_gravity="center_vertical"
                            android:text="@string/set_mode"
                            android:textSize="16sp" />

                        <Spinner
                            android:id="@+id/set_mode"
                            android:layout_width="wrap_content"
                            android:layout_height="wrap_content"
                            android:entries="@array/led_colours" />
                    </LinearLayout>

                    <LinearLayout
                        android:layout_width="match_parent"
                        android:layout_height="wrap_content"
                        android:layout_marginTop="@dimen/settings_option_margin"
                        android:layout_marginBottom="@dimen/settings_option_margin"
                        android:gravity="center_vertical"
                        android:orientation="horizontal">

                        <LinearLayout
                            android:layout_width="0dp"
                            android:layout_height="wrap_content"
                            android:layout_marginEnd="10dp"
                            android:layout_weight="1"
                            android:orientation="vertical">

                            <TextView
                                android:layout_width="wrap_content"
                                android:layout_height="wrap_content"
                                android:text="@string/set_display_timeline_in_list"
                                android:textSize="16sp" />

                            <TextView
                                android:layout_width="wrap_content"
                                android:layout_height="wrap_content"
                                android:text="@string/set_display_timeline_in_list_indication"
                                android:textColor="@color/mastodonC2"
                                android:textSize="12sp" />
                        </LinearLayout>

                        <androidx.appcompat.widget.SwitchCompat
                            android:id="@+id/set_display_timeline_in_list"
                            android:layout_width="wrap_content"
                            android:layout_height="wrap_content" />

                    </LinearLayout>

                    <LinearLayout
                        android:layout_width="match_parent"
                        android:layout_height="wrap_content"
                        android:layout_marginTop="@dimen/settings_option_margin"
                        android:layout_marginBottom="@dimen/settings_option_margin"
                        android:gravity="center_vertical"
                        android:orientation="horizontal">

                        <TextView
                            android:layout_width="0dp"
                            android:layout_height="wrap_content"
                            android:layout_marginEnd="10dp"
                            android:layout_weight="1"
                            android:text="@string/set_unfollow_validation"
                            android:textSize="16sp" />

                        <androidx.appcompat.widget.SwitchCompat
                            android:id="@+id/set_unfollow_validation"
                            android:layout_width="wrap_content"
                            android:layout_height="wrap_content" />

                    </LinearLayout>

                    <LinearLayout
                        android:layout_width="match_parent"
                        android:layout_height="wrap_content"
                        android:orientation="horizontal">

                        <LinearLayout
                            android:layout_width="0dp"
                            android:layout_height="1dp"
                            android:layout_margin="10dp"
                            android:layout_weight="1"
                            android:background="?colorAccent" />

                        <TextView
                            android:layout_width="wrap_content"
                            android:layout_height="wrap_content"
                            android:gravity="center"
                            android:text="@string/set_backup"
                            android:textColor="?colorAccent"
                            android:textSize="16sp" />

                        <LinearLayout
                            android:layout_width="0dp"
                            android:layout_height="1dp"
                            android:layout_margin="10dp"
                            android:layout_weight="1"
                            android:background="?colorAccent" />
                    </LinearLayout>

                    <LinearLayout
                        android:layout_width="match_parent"
                        android:layout_height="wrap_content"
                        android:layout_marginTop="@dimen/settings_option_margin"
                        android:layout_marginBottom="@dimen/settings_option_margin"
                        android:gravity="center_vertical"
                        android:orientation="horizontal">

                        <LinearLayout
                            android:layout_width="0dp"
                            android:layout_height="wrap_content"
                            android:layout_marginEnd="10dp"
                            android:layout_weight="1"
                            android:orientation="vertical">

                            <TextView
                                android:layout_width="wrap_content"
                                android:layout_height="wrap_content"
                                android:text="@string/set_auto_backup"
                                android:textSize="16sp" />

                            <TextView
                                android:layout_width="wrap_content"
                                android:layout_height="wrap_content"
                                android:text="@string/set_auto_backup_indication"
                                android:textColor="@color/mastodonC2"
                                android:textSize="12sp" />
                        </LinearLayout>

                        <androidx.appcompat.widget.SwitchCompat
                            android:id="@+id/set_auto_backup"
                            android:layout_width="wrap_content"
                            android:layout_height="wrap_content" />

                    </LinearLayout>

                    <LinearLayout
                        android:layout_width="match_parent"
                        android:layout_height="wrap_content"
                        android:layout_marginTop="@dimen/settings_option_margin"
                        android:layout_marginBottom="@dimen/settings_option_margin"
                        android:gravity="center_vertical"
                        android:orientation="horizontal">

                        <LinearLayout
                            android:layout_width="0dp"
                            android:layout_height="wrap_content"
                            android:layout_marginEnd="10dp"
                            android:layout_weight="1"
                            android:orientation="vertical">

                            <TextView
                                android:layout_width="wrap_content"
                                android:layout_height="wrap_content"
                                android:text="@string/set_auto_backup_notifications"
                                android:textSize="16sp" />

                            <TextView
                                android:layout_width="wrap_content"
                                android:layout_height="wrap_content"
                                android:text="@string/set_auto_backup_notifications_indication"
                                android:textColor="@color/mastodonC2"
                                android:textSize="12sp" />
                        </LinearLayout>

                        <androidx.appcompat.widget.SwitchCompat
                            android:id="@+id/set_auto_backup_notifications"
                            android:layout_width="wrap_content"
                            android:layout_height="wrap_content" />

                    </LinearLayout>

                    <LinearLayout
                        android:layout_width="match_parent"
                        android:layout_height="wrap_content"
                        android:orientation="horizontal">

                        <LinearLayout
                            android:layout_width="0dp"
                            android:layout_height="1dp"
                            android:layout_margin="10dp"
                            android:layout_weight="1"
                            android:background="?colorAccent" />

                        <TextView
                            android:layout_width="wrap_content"
                            android:layout_height="wrap_content"
                            android:gravity="center"
                            android:text="@string/action_cache"
                            android:textColor="?colorAccent"
                            android:textSize="16sp" />

                        <LinearLayout
                            android:layout_width="0dp"
                            android:layout_height="1dp"
                            android:layout_margin="10dp"
                            android:layout_weight="1"
                            android:background="?colorAccent" />
                    </LinearLayout>

                    <LinearLayout
                        android:layout_width="match_parent"
                        android:layout_height="wrap_content"
                        android:layout_marginTop="@dimen/settings_option_margin"
                        android:layout_marginBottom="@dimen/settings_option_margin"
                        android:gravity="center_vertical"
                        android:orientation="horizontal">

                        <LinearLayout
                            android:layout_width="0dp"
                            android:layout_height="wrap_content"
                            android:layout_marginEnd="10dp"
                            android:layout_weight="1"
                            android:orientation="vertical">

                            <TextView
                                android:layout_width="wrap_content"
                                android:layout_height="wrap_content"
                                android:text="@string/set_clear_cache_exit"
                                android:textSize="16sp" />

                            <TextView
                                android:layout_width="wrap_content"
                                android:layout_height="wrap_content"
                                android:text="@string/set_clear_cache_exit_indication"
                                android:textColor="@color/mastodonC2"
                                android:textSize="12sp" />
                        </LinearLayout>

                        <androidx.appcompat.widget.SwitchCompat
                            android:id="@+id/set_clear_cache_exit"
                            android:layout_width="wrap_content"
                            android:layout_height="wrap_content" />

                    </LinearLayout>

                    <LinearLayout
                        android:layout_width="match_parent"
                        android:layout_height="wrap_content"
                        android:orientation="horizontal">

                        <LinearLayout
                            android:layout_width="0dp"
                            android:layout_height="1dp"
                            android:layout_margin="10dp"
                            android:layout_weight="1"
                            android:background="?colorAccent" />

                        <TextView
                            android:layout_width="wrap_content"
                            android:layout_height="wrap_content"
                            android:gravity="center"
                            android:text="@string/set_crash_reports"
                            android:textColor="?colorAccent"
                            android:textSize="16sp" />

                        <LinearLayout
                            android:layout_width="0dp"
                            android:layout_height="1dp"
                            android:layout_margin="10dp"
                            android:layout_weight="1"
                            android:background="?colorAccent" />
                    </LinearLayout>

                    <LinearLayout
                        android:layout_width="match_parent"
                        android:layout_height="wrap_content"
                        android:layout_marginTop="@dimen/settings_option_margin"
                        android:layout_marginBottom="@dimen/settings_option_margin"
                        android:gravity="center_vertical"
                        android:orientation="horizontal">

                        <LinearLayout
                            android:layout_width="0dp"
                            android:layout_height="wrap_content"
                            android:layout_marginEnd="10dp"
                            android:layout_weight="1"
                            android:orientation="vertical">

                            <TextView
                                android:layout_width="wrap_content"
                                android:layout_height="wrap_content"
                                android:text="@string/set_enable_crash_report"
                                android:textSize="16sp" />

                            <TextView
                                android:layout_width="wrap_content"
                                android:layout_height="wrap_content"
                                android:text="@string/set_enable_crash_report_indication"
                                android:textColor="@color/mastodonC2"
                                android:textSize="12sp" />
                        </LinearLayout>

                        <androidx.appcompat.widget.SwitchCompat
                            android:id="@+id/set_enable_crash_report"
                            android:layout_width="wrap_content"
                            android:layout_height="wrap_content" />

                    </LinearLayout>


                    <LinearLayout
                        android:layout_width="match_parent"
                        android:layout_height="wrap_content"
                        android:layout_gravity="center_vertical"
                        android:orientation="horizontal">

                        <TextView
                            android:layout_width="wrap_content"
                            android:layout_height="wrap_content"
                            android:layout_gravity="center_vertical"
                            android:text="@string/set_attachment_action"
                            android:textSize="16sp" />

                        <Spinner
                            android:id="@+id/set_attachment_group"
                            android:layout_width="wrap_content"
                            android:layout_height="wrap_content"
                            android:entries="@array/led_colours" />
                    </LinearLayout>


                    <LinearLayout
                        android:layout_width="match_parent"
                        android:layout_height="wrap_content"
                        android:layout_marginTop="@dimen/settings_option_margin"
                        android:layout_marginBottom="@dimen/settings_option_margin"
                        android:gravity="center_vertical"
                        android:orientation="horizontal">

                        <LinearLayout
                            android:layout_width="0dp"
                            android:layout_height="wrap_content"
                            android:layout_marginEnd="10dp"
                            android:layout_weight="1"
                            android:orientation="vertical">

                            <TextView
                                android:layout_width="wrap_content"
                                android:layout_height="wrap_content"
                                android:text="@string/set_security_provider"
                                android:textSize="16sp" />

                            <TextView
                                android:layout_width="wrap_content"
                                android:layout_height="wrap_content"
                                android:text="@string/set_security_provider_indication"
                                android:textColor="@color/mastodonC2"
                                android:textSize="12sp" />
                        </LinearLayout>

                        <androidx.appcompat.widget.SwitchCompat
                            android:id="@+id/set_security_provider"
                            android:layout_width="wrap_content"
                            android:layout_height="wrap_content" />

                    </LinearLayout>

                    <!-- Choose stream -->
                    <LinearLayout
                        android:layout_width="match_parent"
                        android:layout_height="wrap_content"
                        android:layout_marginTop="10dp"
                        android:orientation="horizontal">

                        <TextView
                            android:layout_width="wrap_content"
                            android:layout_height="wrap_content"
                            android:layout_gravity="center_vertical"
                            android:text="@string/set_video_mode"
                            android:textSize="16sp" />

                        <Spinner
                            android:id="@+id/set_video_mode"
                            android:layout_width="wrap_content"
                            android:layout_height="wrap_content" />
                    </LinearLayout>

                    <TextView
                        android:layout_width="wrap_content"
                        android:layout_height="wrap_content"
                        android:text="@string/set_video_mode_indication"
                        android:textColor="@color/mastodonC2" />

                    <TextView
                        android:layout_width="wrap_content"
                        android:layout_height="wrap_content"
                        android:layout_marginTop="10dp"
                        android:layout_marginBottom="10dp"
                        android:gravity="center_vertical"
                        android:text="@string/set_video_cache"
                        android:textSize="16sp" />

                    <LinearLayout
                        android:layout_width="match_parent"
                        android:layout_height="wrap_content"
                        android:layout_gravity="center_vertical"
                        android:orientation="horizontal">

                        <TextView
                            android:id="@+id/set_video_cache"
                            android:layout_width="30dp"
                            android:layout_height="wrap_content"
                            android:layout_marginEnd="10dp"
                            android:textSize="16sp"
                            tools:ignore="RtlHardcoded" />

                        <SeekBar
                            android:id="@+id/set_video_cache_size"
                            android:layout_width="match_parent"
                            android:layout_height="wrap_content"
                            android:layout_gravity="center_vertical" />
                    </LinearLayout>


                    <!-- Featured tags -->
                    <LinearLayout
                        android:layout_width="match_parent"
                        android:layout_height="wrap_content"
                        android:layout_marginTop="@dimen/settings_option_margin"
                        android:layout_marginBottom="@dimen/settings_option_margin"
                        android:orientation="vertical">

                        <TextView
                            android:layout_width="wrap_content"
                            android:layout_height="wrap_content"
                            android:labelFor="@+id/set_featured_tags"
                            android:text="@string/featured_hashtags"
                            android:textSize="16sp" />

                        <mabbas007.tagsedittext.TagsEditText
                            android:id="@+id/set_featured_tags"
                            android:layout_width="match_parent"
                            android:layout_height="wrap_content"
                            android:inputType="textMultiLine"
                            android:lines="3"
                            android:minLines="3"
                            TagsEditText:allowSpaceInTag="true"
                            TagsEditText:tagsCloseImagePadding="@dimen/defaultTagsCloseImagePadding"
                            TagsEditText:tagsCloseImageRight="@drawable/tag_close"
                            TagsEditText:tagsTextColor="?colorAccent"
                            TagsEditText:tagsTextSize="@dimen/defaultTagsTextSize" />

                        <TextView
                            android:layout_width="wrap_content"
                            android:layout_height="wrap_content"
                            android:text="@string/featured_hashtags_indication"
                            android:textColor="@color/mastodonC2" />
                    </LinearLayout>


                    <!-- TRUNCATE LONG TOOTS -->
                    <TextView
                        android:layout_width="wrap_content"
                        android:layout_height="wrap_content"
                        android:layout_marginTop="10dp"
                        android:layout_marginBottom="10dp"
                        android:gravity="center_vertical"
                        android:text="@string/set_truncate_toot"
                        android:textSize="16sp" />

                    <LinearLayout
                        android:layout_width="match_parent"
                        android:layout_height="wrap_content"
                        android:layout_gravity="center_vertical"
                        android:orientation="horizontal">

                        <TextView
                            android:id="@+id/set_truncate_toots"
                            android:layout_width="20dp"
                            android:layout_height="wrap_content"
                            android:layout_marginEnd="10dp"
                            android:textSize="16sp"
                            tools:ignore="RtlHardcoded" />

                        <SeekBar
                            android:id="@+id/set_truncate_size"
                            android:layout_width="match_parent"
                            android:layout_height="wrap_content"
                            android:layout_gravity="center_vertical" />
                    </LinearLayout>

                    <!-- Translation engine -->
                    <LinearLayout
                        android:layout_width="match_parent"
                        android:layout_height="wrap_content"
                        android:layout_gravity="center_vertical"
                        android:layout_marginTop="10dp"
                        android:orientation="vertical">

                        <LinearLayout
                            android:layout_width="match_parent"
                            android:layout_height="wrap_content"
                            android:layout_gravity="center_vertical"
                            android:orientation="horizontal">

                            <TextView
                                android:layout_width="wrap_content"
                                android:layout_height="wrap_content"
                                android:layout_gravity="center_vertical"
                                android:text="@string/about_yandex"
                                android:textSize="16sp" />

                            <Spinner
                                android:id="@+id/translation_layout_spinner"
                                android:layout_width="wrap_content"
                                android:layout_height="wrap_content" />

                            <CheckBox
                                android:id="@+id/set_trans_forced"
                                android:layout_width="wrap_content"
                                android:layout_height="wrap_content"
                                android:layout_marginStart="10dp" />
                        </LinearLayout>

                        <EditText
                            android:id="@+id/translation_key"
                            android:layout_width="match_parent"
                            android:layout_height="wrap_content"
                            android:hint="@string/your_api_key"
                            android:importantForAutofill="noExcludeDescendants"
                            android:inputType="text" />
                    </LinearLayout>

                    <LinearLayout
                        android:layout_width="match_parent"
                        android:layout_height="wrap_content"
                        android:layout_marginTop="10dp"
                        android:orientation="vertical">

                        <LinearLayout
                            android:layout_width="match_parent"
                            android:layout_height="wrap_content"
                            android:orientation="horizontal">

                            <TextView
                                android:layout_width="wrap_content"
                                android:layout_height="wrap_content"
                                android:singleLine="true"
                                android:text="@string/set_folder_title"
                                android:textSize="16sp" />

                            <TextView
                                android:id="@+id/set_folder"
                                android:layout_width="0dp"
                                android:layout_height="wrap_content"
                                android:layout_marginStart="10dp"
                                android:layout_weight="1"
                                android:maxLines="2"
                                android:textColor="?colorAccent"
                                android:textStyle="italic" />
                        </LinearLayout>

                        <TextView
                            android:layout_width="match_parent"
                            android:layout_height="wrap_content"
                            android:layout_marginTop="5dp"
                            android:text="@string/click_to_change"
                            android:textSize="12sp"
                            android:textStyle="italic" />
                    </LinearLayout>


                    <!-- NSFW Timeout -->
                    <TextView
                        android:layout_width="wrap_content"
                        android:layout_height="wrap_content"
                        android:layout_marginTop="10dp"
                        android:layout_marginBottom="10dp"
                        android:gravity="center_vertical"
                        android:text="@string/set_nsfw_timeout"
                        android:textSize="16sp" />

                    <LinearLayout
                        android:layout_width="match_parent"
                        android:layout_height="match_parent"
                        android:layout_gravity="center_vertical"
                        android:layout_marginBottom="10dp"
                        android:orientation="horizontal">

                        <TextView
                            android:id="@+id/set_nsfw_timeout_value"
                            android:layout_width="20dp"
                            android:layout_height="wrap_content"
                            android:layout_marginEnd="10dp"
                            android:textSize="16sp" />

                        <SeekBar
                            android:id="@+id/set_nsfw_timeout"
                            android:layout_width="match_parent"
                            android:layout_height="wrap_content"
                            android:layout_gravity="center_vertical" />
                    </LinearLayout>

                    <!-- Media Description Timeout -->
                    <TextView
                        android:id="@+id/textView"
                        android:layout_width="match_parent"
                        android:layout_height="wrap_content"
                        android:layout_marginTop="10dp"
                        android:layout_marginBottom="10dp"
                        android:gravity="center_vertical"
                        android:text="@string/set_med_desc_timeout"
                        android:textSize="16sp" />

                    <LinearLayout
                        android:layout_width="match_parent"
                        android:layout_height="match_parent"
                        android:layout_gravity="center_vertical"
                        android:layout_marginBottom="10dp"
                        android:orientation="horizontal">

                        <TextView
                            android:id="@+id/set_med_desc_timeout_value"
                            android:layout_width="20dp"
                            android:layout_height="wrap_content"
                            android:layout_marginEnd="10dp"
                            android:textSize="16sp" />

                        <SeekBar
                            android:id="@+id/set_med_desc_timeout"
                            android:layout_width="match_parent"
                            android:layout_height="wrap_content"
                            android:layout_gravity="center_vertical" />
                    </LinearLayout>

                    <LinearLayout
                        android:layout_width="match_parent"
                        android:layout_height="wrap_content"
                        android:layout_gravity="center_vertical"
                        android:layout_marginTop="@dimen/settings_option_margin"
                        android:layout_marginBottom="@dimen/settings_option_margin"
                        android:orientation="horizontal">

                        <TextView
                            android:layout_width="wrap_content"
                            android:layout_height="wrap_content"
                            android:layout_gravity="center_vertical"
                            android:text="@string/change_app_icon_experimental"
                            android:textSize="16sp" />

                        <ImageButton
                            android:id="@+id/btn_select_icon"
                            style="@style/colored_button"
                            android:layout_width="40dp"
                            android:layout_height="40dp"
                            android:layout_marginStart="20dp"
                            android:contentDescription="@string/click_to_change_the_app_icon"
                            android:padding="5dp"
                            android:src="@drawable/ic_all_inclusive_menu" />
                    </LinearLayout>
                </LinearLayout>

            </LinearLayout>
        </ScrollView>

    </FrameLayout>
</com.google.android.material.circularreveal.CircularRevealFrameLayout>
